"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var transitionTime = 400;
/**
 * Collapsible
 */

var Collapsible = /*#__PURE__*/function (_Component) {
  _inherits(Collapsible, _Component);

  /**
   * Constructor
   * @param {Object} props - React props
   */
  function Collapsible(props) {
    var _this;

    _classCallCheck(this, Collapsible);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Collapsible).call(this, props));
    _this.state = {
      style: {}
    };
    return _this;
  }
  /**
   * Right when mounted measure the content's height
   */


  _createClass(Collapsible, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var collapsed = this.props.collapsed;
      this.height = this.getHeight();
      this.setState({
        style: {
          height: collapsed ? 0 : this.height,
          overflow: collapsed ? 'hidden' : 'visible'
        }
      });
    }
    /**
     * When collapsing changes reset the content's height
     * @param {object} nextProps - Next props
     */
    // eslint-disable-next-line camelcase

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      // eslint-disable-line camelcase
      var collapsed = this.props.collapsed;

      if (nextProps.collapsed !== collapsed && !this.updating) {
        this.toggleCollapse(nextProps.collapsed);
      }
    }
    /**
     * If content changes reset the content's height
     */

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var collapsed = this.props.collapsed;

      if (this.height !== this.getHeight() && !this.updating) {
        this.height = this.getHeight();
        this.toggleCollapse(collapsed);
      }
    } // istanbul ignore next

    /**
     * Measure content's height
     * @returns {string} - Height in pixels
     */

  }, {
    key: "getHeight",
    value: function getHeight() {
      return this.content.getBoundingClientRect().height;
    }
    /**
     * Collapse or uncollapse
     * changing height and overflow
     * @param {boolean} collapsed - True if it's collapsed
     */

  }, {
    key: "toggleCollapse",
    value: function toggleCollapse(collapsed) {
      var _this2 = this;

      this.updating = true;
      this.setState({
        style: {
          height: collapsed ? 0 : this.height,
          transition: "height ".concat(transitionTime / 1000, "s ease-out"),
          overflow: 'hidden'
        }
      });
      setTimeout(function () {
        _this2.setState({
          style: {
            height: collapsed ? 0 : _this2.getHeight(),
            overflow: collapsed ? 'hidden' : 'visible'
          }
        });

        _this2.updating = false;
      }, transitionTime);
    }
    /**
     * Render method
     * @returns {JSX} - Component template
     */

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var children = this.props.children;
      var style = this.state.style;
      var child = (0, _react.cloneElement)(children, _objectSpread({}, children.props, {
        ref: function ref(content) {
          _this3.content = content;
        }
      }));
      return _react["default"].createElement("div", {
        className: "collapsible",
        style: style
      }, child);
    }
  }]);

  return Collapsible;
}(_react.Component);

exports["default"] = Collapsible;
Collapsible.propTypes = {
  children: _propTypes["default"].element,
  collapsed: _propTypes["default"].bool
};